Main Page Widgets Namespaces Book

# Gtk::TextBuffer Class Reference
[TextView Classes]

Inheritance diagram for Gtk::TextBuffer:

[legend]

List of all members.

## Detailed Description

Multi-line attributed text that can be displayed by one or more Gtk::TextView widgets.

Text in a buffer can be marked with tags. A Gtk::TextBuffer::Tag is an attribute that can be applied to some range of text. For example, a tag might be called "bold" and make the text inside the tag bold. However, the tag concept is more general than that; tags don't have to affect appearance. They can instead affect the behavior of mouse and key presses, "lock" a range of text so the user can't edit it, or countless other things. A tag is represented by a Gtk::TextBuffer::Tag object. One Gtk::TextBuffer::Tag can be applied to any number of text ranges in any number of Gtk::TextBuffers.

Each tag is stored in a Gtk::TextBuffer::TagTable. A tag table defines a set of tags that can be used together. Each buffer has one tag table associated with it; only tags from that tag table can be used with the buffer. A single tag table can be shared between multiple buffers, however.

Most text manipulation is accomplished with iterators, represented by an iterator. The iterator can be used to navigate over characters, words, lines, and sentences.

But iterators can't be used to preserve positions across buffer modifications. To preserve a position, the Gtk::TextBuffer::Mark object is ideal. There are two marks built-in to GtkTextBuffer; these are named "insert" and "selection_bound" and refer to the insertion point and the boundary of the selection which is not the insertion point. If no text is selected, these two marks will be in the same position. You can manipulate what is selected and where the cursor appears by moving these marks around.

Text buffers always contain at least one line, but may be empty (that is, buffers can contain zero characters). The last line in the text buffer never ends in a line separator (such as newline); the other lines in the buffer always end in a line separator. Line separators count as characters when computing character counts and character offsets. Note that some Unicode line separators are represented with multiple bytes in UTF-8, and the two-character sequence "\r\n" is also considered a line separator.

## Public Types

typedef TextChildAnchor | ChildAnchor
typedef TextIter | iterator
typedef TextMark | Mark
typedef TextTag | Tag
typedef TextTagTable | TagTable

## Public Member Functions

void | add_mark (const Glib::RefPtr<TextBuffer::Mark>& mark, const iterator& where)
| Adds the mark at position where.
void | add_selection_clipboard (const Glib::RefPtr<Clipboard>& clipboard)
| Adds clipboard to the list of clipboards in which the selection contents of buffer are available.
void | apply_tag (const Glib::RefPtr<Tag>& tag, const iterator& start, const iterator& end)
| Emits the "apply_tag" signal on buffer.
void | apply_tag_by_name (const Glib::ustring& name, const iterator& start, const iterator& end)
| Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls apply_tag().
void | assign (const char* text_begin, const char* text_end)
void | assign (const Glib::ustring& text)
iterator | backspace (const iterator& iter, bool interactive=true, bool default_editable=true)
| Performs the appropriate action as if the user hit the delete key with the cursor at the position specified by iter.
iterator | begin ()
void | begin_user_action ()
| Called to indicate that the buffer operations between here and a call to end_user_action() are part of a single user-visible operation.
void | copy_clipboard (const Glib::RefPtr<Clipboard>& clipboard)
| Copies the currently-selected text to a clipboard.
Glib::RefPtr<ChildAnchor> | create_child_anchor (const iterator& pos)
Glib::RefPtr<Mark> | create_mark (const iterator& where, bool left_gravity=true)
| Create an anonymous mark.
Glib::RefPtr<TextBuffer::Mark> | create_mark (const Glib::ustring& mark_name, const iterator& where, bool left_gravity=true)
| Creates a mark at position where.
Glib::RefPtr<Tag> | create_tag ()
| Creates an anoymous tag and adds it to the tag table for buffer.
Glib::RefPtr<Tag> | create_tag (const Glib::ustring& tag_name)
| Creates a tag and adds it to the tag table for buffer.
void | cut_clipboard (const Glib::RefPtr<Clipboard>& clipboard, bool default_editable=true)
| Copies the currently-selected text to a clipboard, then deletes said text if it's editable.
void | delete_mark (const Glib::RefPtr<Mark>& mark)
| Deletes mark, so that it's no longer located anywhere in the buffer.
void | delete_mark_by_name (const Glib::ustring& name)
| Deletes the mark named name; the mark must exist.
iterator | end ()
void | end_user_action ()
| Should be paired with a call to begin_user_action().
iterator | erase (const iterator& range_begin, const iterator& range_end)
std::pair<iterator, bool> | erase_interactive (const iterator& range_begin, const iterator& range_end, bool default_editable=true)
bool | erase_selection (bool interactive=true, bool default_editable=true)
| Deletes the range between the "insert" and "selection_bound" marks, that is, the currently-selected text.
void | get_bounds (iterator& range_begin, iterator& range_end)
bool | get_can_create_tags (const Glib::ustring& format) const
| This functions returns the value set with deserialize_set_can_create_tags().
int | get_char_count () const
| Gets the number of characters in the buffer; note that characters and bytes are not the same, you can't e.g. expect the contents of the buffer in string form to be this many bytes long.
Glib::StringArrayHandle | get_deserialize_formats () const
bool | get_has_selection () const
| Indicates whether the buffer has some text currently selected.
Glib::RefPtr<TextBuffer::Mark> | get_insert ()
| Return value: insertion point mark.
iterator | get_iter_at_child_anchor (const Glib::RefPtr<ChildAnchor>& anchor)
| Get the current position of an anchor.
iterator | get_iter_at_line (int line_number)
iterator | get_iter_at_line_index (int line_number, int byte_index)
iterator | get_iter_at_line_offset (int line_number, int char_offset)
iterator | get_iter_at_mark (const Glib::RefPtr<Mark>& mark)
| Get the current position of a mark.
iterator | get_iter_at_offset (int char_offset)
int | get_line_count () const
| Obtains the number of lines in the buffer.
Glib::RefPtr< const TextBuffer::Mark > | get_mark (const Glib::ustring& name) const
| Return value: a Gtk::TextMark, or `0`.
Glib::RefPtr<TextBuffer::Mark> | get_mark (const Glib::ustring& name)
| Return value: a Gtk::TextMark, or `0`.
bool | get_modified () const
| Indicates whether the buffer has been modified since the last call to set_modified() set the modification flag to `false`.
Glib::RefPtr<TextBuffer::Mark> | get_selection_bound ()
| Return value: selection bound mark.
bool | get_selection_bounds (iterator& start, iterator& end) const
| Return value: whether the selection has nonzero length.
Glib::StringArrayHandle | get_serialize_formats () const
Glib::ustring | get_slice (const iterator& start, const iterator& end, bool include_hidden_chars=true) const
| Return value: an allocated UTF-8 string.
Glib::ustring | get_slice (const iterator& start, const iterator& end, bool include_hidden_chars=true)
| Return value: an allocated UTF-8 string.
Glib::RefPtr< const TextBuffer::TagTable > | get_tag_table () const
| Get the Gtk::TextTagTable associated with this buffer.
Glib::RefPtr <TextBuffer::TagTable> | get_tag_table ()
| Get the Gtk::TextTagTable associated with this buffer.
Glib::ustring | get_text (bool include_hidden_chars=true) const
| Returns all the text in the buffer.
Glib::ustring | get_text (bool include_hidden_chars=true)
Glib::ustring | get_text (const iterator& start, const iterator& end, bool include_hidden_chars=true) const
| Return value: an allocated UTF-8 string.
Glib::ustring | get_text (const iterator& start, const iterator& end, bool include_hidden_chars=true)
| Return value: an allocated UTF-8 string.
const GtkTextBuffer* | gobj () const
| Provides access to the underlying C GObject.
GtkTextBuffer* | gobj ()
| Provides access to the underlying C GObject.
GtkTextBuffer* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
iterator | insert (const iterator& pos, const iterator& range_begin, const iterator& range_end)
| Copies text, tags, and pixbufs between range_begin and range_end (the order of range_begin and range_begin doesn't matter) and inserts the copy at pos.
iterator | insert (const iterator& pos, const char* text_begin, const char* text_end)
| Inserts text at position pos.
iterator | insert (const iterator& pos, const Glib::ustring& text)
| Inserts text at position pos.
void | insert_at_cursor (const char* text_begin, const char* text_end)
| Inserts text, using the current cursor position as the insertion point.
void | insert_at_cursor (const Glib::ustring& text)
| Inserts text, using the current cursor position as the insertion point.
iterator | insert_child_anchor (const iterator& pos, const Glib::RefPtr<ChildAnchor>& anchor)
std::pair<iterator, bool> | insert_interactive (const iterator& pos, const iterator& range_begin, const iterator& range_end, bool default_editable=true)
| Same as insert_range(), but does nothing if the insertion point isn't editable.
std::pair<iterator, bool> | insert_interactive (const iterator& pos, const char* text_begin, const char* text_end, bool default_editable=true)
| Like insert(), but the insertion will not occur if pos is at a non-editable location in the buffer.
std::pair<iterator, bool> | insert_interactive (const iterator& pos, const Glib::ustring& text, bool default_editable=true)
| Like insert(), but the insertion will not occur if iter is at a non-editable location in the buffer.
bool | insert_interactive_at_cursor (const char* text_begin, const char* text_end, bool default_editable=true)
| Calls insert_interactive() at the cursor position.
bool | insert_interactive_at_cursor (const Glib::ustring& text, bool default_editable=true)
| Calls insert_interactive() at the cursor position.
iterator | insert_pixbuf (const iterator& pos, const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)
iterator | insert_with_tag (const iterator& pos, const char* text_begin, const char* text_end, const Glib::ustring& tag_name)
iterator | insert_with_tag (const iterator& pos, const Glib::ustring& text, const Glib::ustring& tag_name)
iterator | insert_with_tag (const iterator& pos, const char* text_begin, const char* text_end, const Glib::RefPtr<Tag>& tag)
iterator | insert_with_tag (const iterator& pos, const Glib::ustring& text, const Glib::RefPtr<Tag>& tag)
iterator | insert_with_tags (const iterator& pos, const char* text_begin, const char* text_end, const Glib::ArrayHandle<Glib::RefPtr<Tag>>& tags)
| Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.
iterator | insert_with_tags (const iterator& pos, const Glib::ustring& text, const Glib::ArrayHandle<Glib::RefPtr<Tag>>& tags)
| Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.
iterator | insert_with_tags_by_name (const iterator& pos, const char* text_begin, const char* text_end, const Glib::StringArrayHandle& tag_names)
| Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.
iterator | insert_with_tags_by_name (const iterator& pos, const Glib::ustring& text, const Glib::StringArrayHandle& tag_names)
| Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.
void | move_mark (const Glib::RefPtr<Mark>& mark, const iterator& where)
| Moves mark to the new location where.
void | move_mark_by_name (const Glib::ustring& name, const iterator& where)
| Moves the mark named name (which must exist) to location where.
void | paste_clipboard (const Glib::RefPtr<Clipboard>& clipboard, bool default_editable=true)
void | paste_clipboard (const Glib::RefPtr<Clipboard>& clipboard, const iterator& override_location, bool default_editable=true)
void | place_cursor (const iterator& where)
| This function moves the "insert" and "selection_bound" marks simultaneously.
Glib::PropertyProxy_ReadOnly<int> | property_cursor_position () const
| The position of the insert mark (as offset from the beginning of the buffer).
Glib::PropertyProxy_ReadOnly <bool> | property_has_selection () const
| Whether the buffer has some text currently selected.
Glib::PropertyProxy_ReadOnly <Glib::ustring> | property_text () const
| Current text of the buffer.
Glib::PropertyProxy <Glib::ustring> | property_text ()
| Current text of the buffer.
Glib::ustring | register_deserialize_tagset (const Glib::ustring& tagset_name)
| This function registers GTK+'s internal rich text serialization format with the passed buffer.
Glib::ustring | register_serialize_tagset (const Glib::ustring& tagset_name)
| This function registers GTK+'s internal rich text serialization format with the passed buffer.
void | remove_all_tags (const iterator& start, const iterator& end)
| Removes all tags in the range between start and end.
void | remove_selection_clipboard (const Glib::RefPtr<Clipboard>& clipboard)
| Removes a Gtk::Clipboard added with add_selection_clipboard().
void | remove_tag (const Glib::RefPtr<Tag>& tag, const iterator& start, const iterator& end)
| Emits the "remove_tag" signal.
void | remove_tag_by_name (const Glib::ustring& name, const iterator& start, const iterator& end)
| Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls remove_tag().
void | select_range (const iterator& ins, const iterator& bound)
| This function moves the "insert" and "selection_bound" marks simultaneously.
void | set_can_create_tags (const Glib::ustring& format, bool can_create_tags=true)
| Use this function to allow a rich text deserialization function to create new tags in the receiving buffer.
void | set_modified (bool setting=true)
| Used to keep track of whether the buffer has been modified since the last time it was saved.
void | set_text (const char* text_begin, const char* text_end)
| Removes the current contents of the buffer, and inserts text instead.
void | set_text (const Glib::ustring& text)
| Removes the current contents of the buffer, and inserts text instead.
Glib::SignalProxy3< void, const Glib::RefPtr <TextBuffer::Tag>&, const TextBuffer::iterator&, const TextBuffer::iterator& > | signal_apply_tag ()
Glib::SignalProxy0<void> | signal_begin_user_action ()
Glib::SignalProxy0<void> | signal_changed ()
Glib::SignalProxy0<void> | signal_end_user_action ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const TextBuffer::iterator& > | signal_erase ()
| The delete_range signal is emitted to delete a range from a TextBuffer.
Glib::SignalProxy3< void, const TextBuffer::iterator &, const Glib::ustring&, int > | signal_insert ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const Glib::RefPtr <ChildAnchor >&> | signal_insert_child_anchor ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const Glib::RefPtr <Gdk::Pixbuf >&> | signal_insert_pixbuf ()
Glib::SignalProxy1< void, const Glib::RefPtr <TextBuffer::Mark >&> | signal_mark_deleted ()
Glib::SignalProxy2< void, const TextBuffer::iterator &, const Glib::RefPtr <TextBuffer::Mark >&> | signal_mark_set ()
Glib::SignalProxy0<void> | signal_modified_changed ()
Glib::SignalProxy3< void, const Glib::RefPtr <TextBuffer::Tag>&, const TextBuffer::iterator&, const TextBuffer::iterator& > | signal_remove_tag ()
int | size () const
| See get_char_count().
void | unregister_deserialize_format (const Glib::ustring& format)
| This function unregisters a rich text format that was previously registered using register_deserialize_format() or register_deserialize_tagset().
void | unregister_serialize_format (const Glib::ustring& format)
| This function unregisters a rich text format that was previously registered using register_serialize_format() or register_serialize_tagset().
virtual | ~TextBuffer ()

## Static Public Member Functions

static Glib::RefPtr<TextBuffer> | create (const Glib::RefPtr<TagTable>& tag_table)
static Glib::RefPtr<TextBuffer> | create ()

## Protected Member Functions

virtual void | on_apply_tag (const Glib::RefPtr<TextBuffer::Tag>& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)
virtual void | on_begin_user_action ()
virtual void | on_changed ()
virtual void | on_end_user_action ()
virtual void | on_erase (const TextBuffer::iterator& start, const TextBuffer::iterator& end)
virtual void | on_insert (const TextBuffer::iterator& pos, const Glib::ustring& text, int bytes)
virtual void | on_insert_child_anchor (const TextBuffer::iterator& pos, const Glib::RefPtr<ChildAnchor>& anchor)
virtual void | on_insert_pixbuf (const TextBuffer::iterator& pos, const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)
virtual void | on_mark_deleted (const Glib::RefPtr<TextBuffer::Mark>& mark)
virtual void | on_mark_set (const TextBuffer::iterator& location, const Glib::RefPtr<TextBuffer::Mark>& mark)
virtual void | on_modified_changed ()
virtual void | on_remove_tag (const Glib::RefPtr<TextBuffer::Tag>& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)
| TextBuffer (const Glib::RefPtr<TagTable>& tag_table)
| TextBuffer ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gtk::TextBuffer> | wrap (GtkTextBuffer* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Member Typedef Documentation

typedef TextChildAnchor Gtk::TextBuffer::ChildAnchor

typedef TextIter Gtk::TextBuffer::iterator

typedef TextMark Gtk::TextBuffer::Mark

typedef TextTag Gtk::TextBuffer::Tag

typedef TextTagTable Gtk::TextBuffer::TagTable

## Constructor & Destructor Documentation

virtual Gtk::TextBuffer::~TextBuffer | ( |  | ) | `[virtual]`

Gtk::TextBuffer::TextBuffer | ( |  | ) | `[protected]`

Gtk::TextBuffer::TextBuffer | ( | const Glib::RefPtr<TagTable>& | tag_table | ) | `[explicit, protected]`

## Member Function Documentation

void Gtk::TextBuffer::add_mark | ( | const Glib::RefPtr<TextBuffer::Mark>& | mark,
|  | const iterator& | where |
| ) |  |  |

Adds the mark at position where.

The mark must not be added to another buffer, and if its name is not `0` then there must not be another mark in the buffer with the same name.

Emits the "mark_set" signal as notification of the mark's initial placement.

Since gtkmm 2.12:

Parameters:

  | mark | The mark to add.
  | where | Location to place mark.

void Gtk::TextBuffer::add_selection_clipboard | ( | const Glib::RefPtr<Clipboard>& | clipboard | ) |

Adds clipboard to the list of clipboards in which the selection contents of buffer are available.

In most cases, clipboard will be the Gtk::Clipboard of type Gdk::SELECTION_PRIMARY for a view of buffer.

Parameters:

  | clipboard | A Gtk::Clipboard.

void Gtk::TextBuffer::apply_tag | ( | const Glib::RefPtr<Tag>& | tag,
|  | const iterator& | start,
|  | const iterator& | end |
| ) |  |  |

Emits the "apply_tag" signal on buffer.

The default handler for the signal applies tag to the given range. start and end do not have to be in order.

Parameters:

  | tag | A Gtk::TextTag.
  | start | One bound of range to be tagged.
  | end | Other bound of range to be tagged.

void Gtk::TextBuffer::apply_tag_by_name | ( | const Glib::ustring & | name,
|  | const iterator& | start,
|  | const iterator& | end |
| ) |  |  |

Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls apply_tag().

Parameters:

  | name | Name of a named Gtk::TextTag.
  | start | One bound of range to be tagged.
  | end | Other bound of range to be tagged.

void Gtk::TextBuffer::assign | ( | const char * | text_begin,
|  | const char * | text_end |
| ) |  |  |

Deprecated:
  Use set_text()

void Gtk::TextBuffer::assign | ( | const Glib::ustring & | text | ) |

Deprecated:
  Use set_text()

iterator Gtk::TextBuffer::backspace | ( | const iterator& | iter,
|  | bool | interactive = `true`,
|  | bool | default_editable = `true` |
| ) |  |  |

Performs the appropriate action as if the user hit the delete key with the cursor at the position specified by iter.

In the normal case a single character will be deleted, but when combining accents are involved, more than one character can be deleted, and when precomposed character and accent combinations are involved, less than one character will be deleted.

Because the buffer is modified, all outstanding iterators become invalid after calling this method; however, this method returns a valid iterator that points to the location where text was deleted.

Parameters:

  | iter | A position in the buffer.
  | interactive | Whether the deletion is caused by user interaction.
  | default_editable | Whether the buffer is editable by default.

Returns:
  An iterator to the location where text was deleted, if the buffer was modified.

Since gtkmm 2.6:

iterator Gtk::TextBuffer::begin | ( |  | ) |

void Gtk::TextBuffer::begin_user_action | ( |  | ) |

Called to indicate that the buffer operations between here and a call to end_user_action() are part of a single user-visible operation.

The operations between begin_user_action() and end_user_action() can then be grouped when creating an undo stack. Gtk::TextBuffer maintains a count of calls to begin_user_action() that have not been closed with a call to end_user_action(), and emits the "begin_user_action" and "end_user_action" signals only for the outermost pair of calls. This allows you to build user actions from other user actions.

The "interactive" buffer mutation functions, such as insert_interactive(), automatically call begin/end user action around the buffer operations they perform, so there's no need to add extra calls if you user action consists solely of a single call to one of those functions.

void Gtk::TextBuffer::copy_clipboard | ( | const Glib::RefPtr<Clipboard>& | clipboard | ) |

Copies the currently-selected text to a clipboard.

Parameters:

  | clipboard | The Gtk::Clipboard object to copy to.

static Glib::RefPtr<TextBuffer> Gtk::TextBuffer::create | ( | const Glib::RefPtr<TagTable>& | tag_table | ) | `[static]`

static Glib::RefPtr<TextBuffer> Gtk::TextBuffer::create | ( |  | ) | `[static]`

Glib::RefPtr<ChildAnchor> Gtk::TextBuffer::create_child_anchor | ( | const iterator& | pos | ) |

Glib::RefPtr<Mark> Gtk::TextBuffer::create_mark | ( | const iterator& | where,
|  | bool | left_gravity = `true` |
| ) |  |  |

Create an anonymous mark.

Creates an anonymous mark at position where.

If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity ( left_gravity = `false`), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Emits the "mark_set" signal as notification of the mark's initial placement.

Parameters:

  | where | Location to place mark.
  | left_gravity | Whether the mark has left gravity.

Returns:
  The new Gtk::TextMark object.

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::create_mark | ( | const Glib::ustring & | mark_name,
|  | const iterator& | where,
|  | bool | left_gravity = `true` |
| ) |  |  |

Creates a mark at position where.

The mark can be retrieved by name using get_mark(). If a mark has left gravity, and text is inserted at the mark's current location, the mark will be moved to the left of the newly-inserted text. If the mark has right gravity ( left_gravity = `false`), the mark will end up on the right of newly-inserted text. The standard left-to-right cursor is a mark with right gravity (when you type, the cursor stays on the right side of the text you're typing).

Emits the "mark_set" signal as notification of the mark's initial placement.

Parameters:

  | mark_name | Name for mark, or `0`.
  | where | Location to place mark.
  | left_gravity | Whether the mark has left gravity.

Returns:
  The new Gtk::TextMark object.

Glib::RefPtr<Tag> Gtk::TextBuffer::create_tag | ( |  | ) |

Creates an anoymous tag and adds it to the tag table for buffer.

Equivalent to calling Gtk::TextBuffer::Tag::create() and then adding the tag to the buffer's tag table.

Returns:
  The new tag.

Glib::RefPtr<Tag> Gtk::TextBuffer::create_tag | ( | const Glib::ustring & | tag_name | ) |

Creates a tag and adds it to the tag table for buffer.

Equivalent to calling Gtk::TextBuffer::Tag::create() and then adding the tag to the buffer's tag table. A tag called tag_name must not already exist in the tag table for this buffer.

Parameters:

  | tag_name | The name for the new tag.

Returns:
  The new tag.

void Gtk::TextBuffer::cut_clipboard | ( | const Glib::RefPtr<Clipboard>& | clipboard,
|  | bool | default_editable = `true` |
| ) |  |  |

Copies the currently-selected text to a clipboard, then deletes said text if it's editable.

Parameters:

  | clipboard | The Gtk::Clipboard object to cut to.
  | default_editable | Default editability of the buffer.

void Gtk::TextBuffer::delete_mark | ( | const Glib::RefPtr<Mark>& | mark | ) |

Deletes mark, so that it's no longer located anywhere in the buffer.

Removes the reference the buffer holds to the mark, so if you don't keep a Glib::RefPtr to the mark, it will be freed. Even if the mark isn't freed, most operations on mark become invalid. There is no way to undelete a mark. Gtk::TextMark::get_deleted() will return `true` after this function has been called on a mark; Gtk::TextMark::get_deleted() indicates that a mark no longer belongs to a buffer. The "mark_deleted" signal will be emitted as notification after the mark is deleted.

Parameters:

  | mark | A Gtk::TextMark in buffer.

void Gtk::TextBuffer::delete_mark_by_name | ( | const Glib::ustring & | name | ) |

Deletes the mark named name; the mark must exist.

See delete_mark() for details.

Parameters:

  | name | Name of a mark in buffer.

iterator Gtk::TextBuffer::end | ( |  | ) |

void Gtk::TextBuffer::end_user_action | ( |  | ) |

Should be paired with a call to begin_user_action().

See that function for a full explanation.

iterator Gtk::TextBuffer::erase | ( | const iterator& | range_begin,
|  | const iterator& | range_end |
| ) |  |  |

std::pair<iterator,bool> Gtk::TextBuffer::erase_interactive | ( | const iterator& | range_begin,
|  | const iterator& | range_end,
|  | bool | default_editable = `true` |
| ) |  |  |

bool Gtk::TextBuffer::erase_selection | ( | bool | interactive = `true`,
|  | bool | default_editable = `true` |
| ) |  |  |

Deletes the range between the "insert" and "selection_bound" marks, that is, the currently-selected text.

If interactive is `true`, the editability of the selection will be considered (users can't delete uneditable text).

Parameters:

  | interactive | Whether the deletion is caused by user interaction.
  | default_editable | Whether the buffer is editable by default.

Returns:
  Whether there was a non-empty selection to delete.

void Gtk::TextBuffer::get_bounds | ( | iterator& | range_begin,
|  | iterator& | range_end |
| ) |  |  |

bool Gtk::TextBuffer::get_can_create_tags | ( | const Glib::ustring & | format | ) | const

This functions returns the value set with deserialize_set_can_create_tags().

Parameters:

  | format | A Gdk::Atom representing a registered rich text format.

Returns:
  Whether deserializing this format may create tags

Since gtkmm 2.10:

int Gtk::TextBuffer::get_char_count | ( |  | ) | const

Gets the number of characters in the buffer; note that characters and bytes are not the same, you can't e.g. expect the contents of the buffer in string form to be this many bytes long.

The character count is cached, so this function is very fast.

Returns:
  Number of characters in the buffer.

Glib::StringArrayHandle Gtk::TextBuffer::get_deserialize_formats | ( |  | ) | const

bool Gtk::TextBuffer::get_has_selection | ( |  | ) | const

Indicates whether the buffer has some text currently selected.

Returns:
  `true` if the there is text selected

Since gtkmm 2.10:

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::get_insert | ( |  | ) |

Return value: insertion point mark.

Returns:
  Insertion point mark.

iterator Gtk::TextBuffer::get_iter_at_child_anchor | ( | const Glib::RefPtr<ChildAnchor>& | anchor | ) |

Get the current position of an anchor.

Parameters:

  | anchor | A Gtk::TextBuffer::Anchor that appears in the buffer.

Returns:
  An iterator that points to the position of the anchor.

iterator Gtk::TextBuffer::get_iter_at_line | ( | int | line_number | ) |

iterator Gtk::TextBuffer::get_iter_at_line_index | ( | int | line_number,
|  | int | byte_index |
| ) |  |  |

iterator Gtk::TextBuffer::get_iter_at_line_offset | ( | int | line_number,
|  | int | char_offset |
| ) |  |  |

iterator Gtk::TextBuffer::get_iter_at_mark | ( | const Glib::RefPtr<Mark>& | mark | ) |

Get the current position of a mark.

Parameters:

  | mark | The Gtk::TextBuffer::Mark

Returns:
  An iterator that points to the position of the mark.

iterator Gtk::TextBuffer::get_iter_at_offset | ( | int | char_offset | ) |

int Gtk::TextBuffer::get_line_count | ( |  | ) | const

Obtains the number of lines in the buffer.

This value is cached, so the function is very fast.

Returns:
  Number of lines in the buffer.

Glib::RefPtr<const TextBuffer::Mark> Gtk::TextBuffer::get_mark | ( | const Glib::ustring & | name | ) | const

Return value: a Gtk::TextMark, or `0`.

Parameters:

  | name | A mark name.

Returns:
  A Gtk::TextMark, or `0`.

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::get_mark | ( | const Glib::ustring & | name | ) |

Return value: a Gtk::TextMark, or `0`.

Parameters:

  | name | A mark name.

Returns:
  A Gtk::TextMark, or `0`.

bool Gtk::TextBuffer::get_modified | ( |  | ) | const

Indicates whether the buffer has been modified since the last call to set_modified() set the modification flag to `false`.

Used for example to enable a "save" function in a text editor.

Returns:
  `true` if the buffer has been modified.

Glib::RefPtr<TextBuffer::Mark> Gtk::TextBuffer::get_selection_bound | ( |  | ) |

Return value: selection bound mark.

Returns:
  Selection bound mark.

bool Gtk::TextBuffer::get_selection_bounds | ( | iterator& | start,
|  | iterator& | end |
| ) |  |  | const

Return value: whether the selection has nonzero length.

Parameters:

  | start | Iterator to initialize with selection start.
  | end | Iterator to initialize with selection end.

Returns:
  Whether the selection has nonzero length.

Glib::StringArrayHandle Gtk::TextBuffer::get_serialize_formats | ( |  | ) | const

Glib::ustring Gtk::TextBuffer::get_slice | ( | const iterator& | start,
|  | const iterator& | end,
|  | bool | include_hidden_chars = `true` |
| ) |  |  | const

Return value: an allocated UTF-8 string.

Parameters:

  | start | Start of a range.
  | end | End of a range.
  | include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

Glib::ustring Gtk::TextBuffer::get_slice | ( | const iterator& | start,
|  | const iterator& | end,
|  | bool | include_hidden_chars = `true` |
| ) |  |  |

Return value: an allocated UTF-8 string.

@param start Start of a range.

Parameters:

  | end | End of a range.
  | include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

Glib::RefPtr<const TextBuffer::TagTable> Gtk::TextBuffer::get_tag_table | ( |  | ) | const

Get the Gtk::TextTagTable associated with this buffer.

Returns:
  The buffer's tag table.

Glib::RefPtr<TextBuffer::TagTable> Gtk::TextBuffer::get_tag_table | ( |  | ) |

Get the Gtk::TextTagTable associated with this buffer.

Returns:
  The buffer's tag table.

Glib::ustring Gtk::TextBuffer::get_text | ( | bool | include_hidden_chars = `true` | ) | const

Returns all the text in the buffer.

Excludes undisplayed text (text marked with tags that set the invisibility attribute) if include_hidden_chars is `false`. Does not include characters representing embedded images, so byte and character indexes into the returned string do not correspond to byte and character indexes into the buffer. Contrast with get_slice().

Parameters:

  | include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

Glib::ustring Gtk::TextBuffer::get_text | ( | bool | include_hidden_chars = `true` | ) |

Deprecated:
  Use get_text(bool include_hidden_chars) const.

Glib::ustring Gtk::TextBuffer::get_text | ( | const iterator& | start,
|  | const iterator& | end,
|  | bool | include_hidden_chars = `true` |
| ) |  |  | const

Return value: an allocated UTF-8 string.

Parameters:

  | start | Start of a range.
  | end | End of a range.
  | include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

Glib::ustring Gtk::TextBuffer::get_text | ( | const iterator& | start,
|  | const iterator& | end,
|  | bool | include_hidden_chars = `true` |
| ) |  |  |

Return value: an allocated UTF-8 string.

@param start Start of a range.

Parameters:

  | end | End of a range.
  | include_hidden_chars | Whether to include invisible text.

Returns:
  An allocated UTF-8 string.

const GtkTextBuffer* Gtk::TextBuffer::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkTextBuffer* Gtk::TextBuffer::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkTextBuffer* Gtk::TextBuffer::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

iterator Gtk::TextBuffer::insert | ( | const iterator& | pos,
|  | const iterator& | range_begin,
|  | const iterator& | range_end |
| ) |  |  |

Copies text, tags, and pixbufs between range_begin and range_end (the order of range_begin and range_begin doesn't matter) and inserts the copy at pos.

Used instead of simply getting/inserting text because it preserves images and tags. If range_begin and range_end are in a different buffer, the two buffers must share the same tag table.

Implemented via emissions of the insert_text and apply_tag signals, so expect those.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | range_begin | A position in a buffer.
  | range_end | Another position in the same buffer as range_begin.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end |
| ) |  |  |

Inserts text at position pos.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal. The pos iterator is invalidated when insertion occurs (because the buffer contents change).

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.

Returns:
  An iterator that points to the end of the inserted text.

iterator Gtk::TextBuffer::insert | ( | const iterator& | pos,
|  | const Glib::ustring & | text |
| ) |  |  |

Inserts text at position pos.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal. The pos iterator is invalidated when insertion occurs (because the buffer contents change).

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text | The text to be inserted in the buffer.

Returns:
  An iterator that points to the end of the inserted text.

void Gtk::TextBuffer::insert_at_cursor | ( | const char * | text_begin,
|  | const char * | text_end |
| ) |  |  |

Inserts text, using the current cursor position as the insertion point.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal.

Parameters:

  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.

Returns:
  An iterator that points to the end of the inserted text.

void Gtk::TextBuffer::insert_at_cursor | ( | const Glib::ustring & | text | ) |

Inserts text, using the current cursor position as the insertion point.

Emits the "insert_text" signal; insertion actually occurs in the default handler for the signal.

Parameters:

  | text | The text to be inserted in the buffer.

Returns:
  An iterator that points to the end of the inserted text.

iterator Gtk::TextBuffer::insert_child_anchor | ( | const iterator& | pos,
|  | const Glib::RefPtr<ChildAnchor>& | anchor |
| ) |  |  |

std::pair<iterator,bool> Gtk::TextBuffer::insert_interactive | ( | const iterator& | pos,
|  | const iterator& | range_begin,
|  | const iterator& | range_end,
|  | bool | default_editable = `true` |
| ) |  |  |

Same as insert_range(), but does nothing if the insertion point isn't editable.

The default_editable parameter indicates whether the text is editable at pos if no tags enclosing pos affect editability. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | range_begin | A position in a buffer.
  | range_end | Another position in the same buffer as range_begin.
  | default_editable | Default editability of buffer.

Returns:
  Whether text was actually inserted

std::pair<iterator,bool> Gtk::TextBuffer::insert_interactive | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | bool | default_editable = `true` |
| ) |  |  |

Like insert(), but the insertion will not occur if pos is at a non-editable location in the buffer.

Usually you want to prevent insertions at ineditable locations if the insertion results from a user action (is interactive).

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.
  | default_editable | Default editability of buffer.

Returns:
  Whether text was actually inserted

std::pair<iterator,bool> Gtk::TextBuffer::insert_interactive | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | bool | default_editable = `true` |
| ) |  |  |

Like insert(), but the insertion will not occur if iter is at a non-editable location in the buffer.

Usually you want to prevent insertions at ineditable locations if the insertion results from a user action (is interactive).

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text | The text to be inserted in the buffer.
  | default_editable | Default editability of buffer

Returns:
  Whether text was actually inserted

bool Gtk::TextBuffer::insert_interactive_at_cursor | ( | const char * | text_begin,
|  | const char * | text_end,
|  | bool | default_editable = `true` |
| ) |  |  |

Calls insert_interactive() at the cursor position.

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.
  | default_editable | Default editability of buffer

Returns:
  Whether text was actually inserted

bool Gtk::TextBuffer::insert_interactive_at_cursor | ( | const Glib::ustring & | text,
|  | bool | default_editable = `true` |
| ) |  |  |

Calls insert_interactive() at the cursor position.

default_editable indicates the editability of text that doesn't have a tag affecting editability applied to it. Typically the result of Gtk::TextView::get_editable() is appropriate here.

Parameters:

  | text | The text to be inserted in the buffer.
  | default_editable | Default editability of buffer

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_pixbuf | ( | const iterator& | pos,
|  | const Glib::RefPtr<Gdk::Pixbuf>& | pixbuf |
| ) |  |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const Glib::ustring & | tag_name |
| ) |  |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const Glib::ustring & | tag_name |
| ) |  |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const Glib::RefPtr<Tag>& | tag |
| ) |  |  |

iterator Gtk::TextBuffer::insert_with_tag | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const Glib::RefPtr<Tag>& | tag |
| ) |  |  |

iterator Gtk::TextBuffer::insert_with_tags | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const Glib::ArrayHandle<Glib::RefPtr<Tag>>& | tags |
| ) |  |  |

Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.
  | tags | A standard C++ container of Gtk::TextBuffer::Tags.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_with_tags | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const Glib::ArrayHandle<Glib::RefPtr<Tag>>& | tags |
| ) |  |  |

Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text | The text to be inserted in the buffer.
  | tags | A standard C++ container of Gtk::TextBuffer::Tags.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_with_tags_by_name | ( | const iterator& | pos,
|  | const char * | text_begin,
|  | const char * | text_end,
|  | const Glib::StringArrayHandle & | tag_names |
| ) |  |  |

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.
  | tag_names | A standard C++ container of tag names.

Returns:
  Whether text was actually inserted

iterator Gtk::TextBuffer::insert_with_tags_by_name | ( | const iterator& | pos,
|  | const Glib::ustring & | text,
|  | const Glib::StringArrayHandle & | tag_names |
| ) |  |  |

Inserts text into buffer at pos, applying the list of tags to the newly-inserted text.

Equivalent to calling insert(), then apply_tag() on the inserted text; This is just a convenience function.

Parameters:

  | pos | An iterator pointing to the position at which the text should be inserted.
  | text | The text to be inserted in the buffer.
  | tag_names | A standard C++ container of tag names.

Returns:
  Whether text was actually inserted

void Gtk::TextBuffer::move_mark | ( | const Glib::RefPtr<Mark>& | mark,
|  | const iterator& | where |
| ) |  |  |

Moves mark to the new location where.

Emits the "mark_set" signal as notification of the move.

Parameters:

  | mark | A Gtk::TextMark.
  | where | New location for mark in buffer.

void Gtk::TextBuffer::move_mark_by_name | ( | const Glib::ustring & | name,
|  | const iterator& | where |
| ) |  |  |

Moves the mark named name (which must exist) to location where.

See move_mark() for details.

Parameters:

  | name | Name of a mark.
  | where | New location for mark.

virtual void Gtk::TextBuffer::on_apply_tag | ( | const Glib::RefPtr<TextBuffer::Tag>& | tag,
|  | const TextBuffer::iterator& | range_begin,
|  | const TextBuffer::iterator& | range_end |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_begin_user_action | ( |  | ) | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_changed | ( |  | ) | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_end_user_action | ( |  | ) | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_erase | ( | const TextBuffer::iterator& | start,
|  | const TextBuffer::iterator& | end |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_insert | ( | const TextBuffer::iterator& | pos,
|  | const Glib::ustring & | text,
|  | int | bytes |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_insert_child_anchor | ( | const TextBuffer::iterator& | pos,
|  | const Glib::RefPtr<ChildAnchor>& | anchor |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_insert_pixbuf | ( | const TextBuffer::iterator& | pos,
|  | const Glib::RefPtr<Gdk::Pixbuf>& | pixbuf |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_mark_deleted | ( | const Glib::RefPtr<TextBuffer::Mark>& | mark | ) | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_mark_set | ( | const TextBuffer::iterator& | location,
|  | const Glib::RefPtr<TextBuffer::Mark>& | mark |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_modified_changed | ( |  | ) | `[protected, virtual]`

virtual void Gtk::TextBuffer::on_remove_tag | ( | const Glib::RefPtr<TextBuffer::Tag>& | tag,
|  | const TextBuffer::iterator& | range_begin,
|  | const TextBuffer::iterator& | range_end |
| ) |  |  | `[protected, virtual]`

void Gtk::TextBuffer::paste_clipboard | ( | const Glib::RefPtr<Clipboard>& | clipboard,
|  | bool | default_editable = `true` |
| ) |  |  |

void Gtk::TextBuffer::paste_clipboard | ( | const Glib::RefPtr<Clipboard>& | clipboard,
|  | const iterator& | override_location,
|  | bool | default_editable = `true` |
| ) |  |  |

void Gtk::TextBuffer::place_cursor | ( | const iterator& | where | ) |

This function moves the "insert" and "selection_bound" marks simultaneously.

If you move them to the same place in two steps with move_mark(), you will temporarily select a region in between their old and new locations, which can be pretty inefficient since the temporarily-selected region will force stuff to be recalculated. This function moves them as a unit, which can be optimized.

Parameters:

  | where | Where to put the cursor.

Glib::PropertyProxy_ReadOnly<int> Gtk::TextBuffer::property_cursor_position | ( |  | ) | const

The position of the insert mark (as offset from the beginning of the buffer).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::TextBuffer::property_has_selection | ( |  | ) | const

Whether the buffer has some text currently selected.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::TextBuffer::property_text | ( |  | ) | const

Current text of the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gtk::TextBuffer::property_text | ( |  | ) |

Current text of the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::ustring Gtk::TextBuffer::register_deserialize_tagset | ( | const Glib::ustring & | tagset_name | ) |

This function registers GTK+'s internal rich text serialization format with the passed buffer.

See register_serialize_tagset() for details.

Parameters:

  | tagset_name | An optional tagset name, on `0`.

Returns:
  The Gdk::Atom that corresponds to the newly registered format's mime-type.

Since gtkmm 2.10:

Glib::ustring Gtk::TextBuffer::register_serialize_tagset | ( | const Glib::ustring & | tagset_name | ) |

This function registers GTK+'s internal rich text serialization format with the passed buffer.

The internal format does not comply to any standard rich text format and only works between Gtk::TextBuffer instances. It is capable of serializing all of a text buffer's tags and embedded pixbufs.

This function is just a wrapper around register_serialize_format(). The mime type used for registering is "application/x-gtk-text-buffer-rich-text", or "application/x-gtk-text-buffer-rich-text;format= @a tagset_name" if a tagset_name was passed.

The tagset_name can be used to restrict the transfer of rich text to buffers with compatible sets of tags, in order to avoid unknown tags from being pasted. It is probably the common case to pass an identifier != `0` here, since the `0` tagset requires the receiving buffer to deal with with pasting of arbitrary tags.

Parameters:

  | tagset_name | An optional tagset name, on `0`.

Returns:
  The Gdk::Atom that corresponds to the newly registered format's mime-type.

Since gtkmm 2.10:

void Gtk::TextBuffer::remove_all_tags | ( | const iterator& | start,
|  | const iterator& | end |
| ) |  |  |

Removes all tags in the range between start and end.

Be careful with this function; it could remove tags added in code unrelated to the code you're currently writing. That is, using this function is probably a bad idea if you have two or more unrelated code sections that add tags.

Parameters:

  | start | One bound of range to be untagged.
  | end | Other bound of range to be untagged.

void Gtk::TextBuffer::remove_selection_clipboard | ( | const Glib::RefPtr<Clipboard>& | clipboard | ) |

Removes a Gtk::Clipboard added with add_selection_clipboard().

Parameters:

  | clipboard | A Gtk::Clipboard added to buffer by add_selection_clipboard().

void Gtk::TextBuffer::remove_tag | ( | const Glib::RefPtr<Tag>& | tag,
|  | const iterator& | start,
|  | const iterator& | end |
| ) |  |  |

Emits the "remove_tag" signal.

The default handler for the signal removes all occurrences of tag from the given range. start and end don't have to be in order.

Parameters:

  | tag | A Gtk::TextTag.
  | start | One bound of range to be untagged.
  | end | Other bound of range to be untagged.

void Gtk::TextBuffer::remove_tag_by_name | ( | const Glib::ustring & | name,
|  | const iterator& | start,
|  | const iterator& | end |
| ) |  |  |

Calls Gtk::TextTagTable::lookup() on the buffer's tag table to get a Gtk::TextTag, then calls remove_tag().

Parameters:

  | name | Name of a Gtk::TextTag.
  | start | One bound of range to be untagged.
  | end | Other bound of range to be untagged.

void Gtk::TextBuffer::select_range | ( | const iterator& | ins,
|  | const iterator& | bound |
| ) |  |  |

This function moves the "insert" and "selection_bound" marks simultaneously.

If you move them in two steps with move_mark(), you will temporarily select a region in between their old and new locations, which can be pretty inefficient since the temporarily-selected region will force stuff to be recalculated. This function moves them as a unit, which can be optimized.

Since gtkmm 2.4:

Parameters:

  | ins | Where to put the "insert" mark.
  | bound | Where to put the "selection_bound" mark.

void Gtk::TextBuffer::set_can_create_tags | ( | const Glib::ustring & | format,
|  | bool | can_create_tags = `true` |
| ) |  |  |

Use this function to allow a rich text deserialization function to create new tags in the receiving buffer.

Note that using this function is almost always a bad idea, because the rich text functions you register should know how to map the rich text format they handler to your text buffers set of tags.

The ability of creating new (arbitrary!) tags in the receiving buffer is meant for special rich text formats like the internal one that is registered using register_deserialize_tagset(), because that format is essentially a dump of the internal structure of the source buffer, including its tag names.

You should allow creation of tags only if you know what you are doing, e.g. if you defined a tagset name for your application suite's text buffers and you know that it's fine to receive new tags from these buffers, because you know that your application can handle the newly created tags.

Since gtkmm 2.10:

Parameters:

  | format | A Gdk::Atom representing a registered rich text format.
  | can_create_tags | Whether deserializing this format may create tags.

void Gtk::TextBuffer::set_modified | ( | bool | setting = `true` | ) |

Used to keep track of whether the buffer has been modified since the last time it was saved.

Whenever the buffer is saved to disk, call gtk_text_buffer_set_modified ( buffer, `false`). When the buffer is modified, it will automatically toggled on the modified bit again. When the modified bit flips, the buffer emits a "modified_changed" signal.

Parameters:

  | setting | Modification flag setting.

void Gtk::TextBuffer::set_text | ( | const char * | text_begin,
|  | const char * | text_end |
| ) |  |  |

Removes the current contents of the buffer, and inserts text instead.

Parameters:

  | text_begin | The start of a UTF8 character array.
  | text_end | The end of the UTF8 character array.

void Gtk::TextBuffer::set_text | ( | const Glib::ustring & | text | ) |

Removes the current contents of the buffer, and inserts text instead.

Parameters:

  | text | The text to put in the buffer.

Glib::SignalProxy3<void,const Glib::RefPtr<TextBuffer::Tag>&,const TextBuffer::iterator&,const TextBuffer::iterator&> Gtk::TextBuffer::signal_apply_tag | ( |  | ) |

Prototype:
  `void on_my_apply_tag(const Glib::RefPtr<TextBuffer::Tag>& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)`

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_begin_user_action | ( |  | ) |

Prototype:
  `void on_my_begin_user_action()`

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_changed | ( |  | ) |

Prototype:
  `void on_my_changed()`

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_end_user_action | ( |  | ) |

Prototype:
  `void on_my_end_user_action()`

Glib::SignalProxy2<void,const TextBuffer::iterator&,const TextBuffer::iterator&> Gtk::TextBuffer::signal_erase | ( |  | ) |

The delete_range signal is emitted to delete a range from a TextBuffer.

Note that your handler must not invalidate the start and end iters (or has to revalidate them), if it runs before the default handler. There is no need to keep the iters valid in handlers which run after the default handler but those don't have access to the deleted text.

Parameters:

  | start | the start of the range to be deleted.
  | end | the end of the range to be deleted.

Prototype:
  `void on_my_erase(const TextBuffer::iterator& start, const TextBuffer::iterator& end)`

Glib::SignalProxy3<void,const TextBuffer::iterator&,const Glib::ustring&,int> Gtk::TextBuffer::signal_insert | ( |  | ) |

Prototype:
  `void on_my_insert(const TextBuffer::iterator& pos, const Glib::ustring& text, int bytes)`

Glib::SignalProxy2<void,const TextBuffer::iterator&,const Glib::RefPtr<ChildAnchor>&> Gtk::TextBuffer::signal_insert_child_anchor | ( |  | ) |

Prototype:
  `void on_my_insert_child_anchor(const TextBuffer::iterator& pos, const Glib::RefPtr<ChildAnchor>& anchor)`

Glib::SignalProxy2<void,const TextBuffer::iterator&,const Glib::RefPtr<Gdk::Pixbuf>&> Gtk::TextBuffer::signal_insert_pixbuf | ( |  | ) |

Prototype:
  `void on_my_insert_pixbuf(const TextBuffer::iterator& pos, const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)`

Glib::SignalProxy1<void,const Glib::RefPtr<TextBuffer::Mark>&> Gtk::TextBuffer::signal_mark_deleted | ( |  | ) |

Prototype:
  `void on_my_mark_deleted(const Glib::RefPtr<TextBuffer::Mark>& mark)`

Glib::SignalProxy2<void,const TextBuffer::iterator&,const Glib::RefPtr<TextBuffer::Mark>&> Gtk::TextBuffer::signal_mark_set | ( |  | ) |

Prototype:
  `void on_my_mark_set(const TextBuffer::iterator& location, const Glib::RefPtr<TextBuffer::Mark>& mark)`

Glib::SignalProxy0< void > Gtk::TextBuffer::signal_modified_changed | ( |  | ) |

Prototype:
  `void on_my_modified_changed()`

Glib::SignalProxy3<void,const Glib::RefPtr<TextBuffer::Tag>&,const TextBuffer::iterator&,const TextBuffer::iterator&> Gtk::TextBuffer::signal_remove_tag | ( |  | ) |

Prototype:
  `void on_my_remove_tag(const Glib::RefPtr<TextBuffer::Tag>& tag, const TextBuffer::iterator& range_begin, const TextBuffer::iterator& range_end)`

int Gtk::TextBuffer::size | ( |  | ) | const

See get_char_count().

void Gtk::TextBuffer::unregister_deserialize_format | ( | const Glib::ustring & | format | ) |

This function unregisters a rich text format that was previously registered using register_deserialize_format() or register_deserialize_tagset().

Since gtkmm 2.10:

Parameters:

  | format | A Gdk::Atom representing a registered rich text format.

void Gtk::TextBuffer::unregister_serialize_format | ( | const Glib::ustring & | format | ) |

This function unregisters a rich text format that was previously registered using register_serialize_format() or register_serialize_tagset().

Since gtkmm 2.10:

Parameters:

  | format | A Gdk::Atom representing a registered rich text format.

## Friends And Related Function Documentation

Glib::RefPtr<Gtk::TextBuffer> wrap | ( | GtkTextBuffer * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- textbuffer.h